addpath visualization;
if isunix()
  addpath mex_unix;
elseif ispc()
  addpath mex_pc;
end

compile;

% load and display model
load('PARSE_model');
%visualizemodel(model);
disp('started');
%disp('press any key to continue'); 
%pause;
%visualizeskeleton(model);
%disp('model tree visualization');
%disp('press any key to continue'); 
%pause;

imlist = dir('images/*.png');
fprintf('Total Number of frames = %d\n ',length(imlist));

for i = 1:length(imlist)
    % load and display image
    im = imread(['images/' imlist(i).name]);
    %clf; imagesc(im); axis image; axis off; drawnow;

    % call detect function
    tic;
    fprintf('Frame Number %d Running\n',i);
    boxes = detect_fast(im, model, min(model.thresh,-1));
    dettime = toc; % record cpu time
    boxes = nms(boxes, .1); % nonmaximal suppression
   % demoimid = 1;
   % box = boxes{demoimid};
    colorset = {'g','g','y','m','m','m','m','y','y','y','r','r','r','r','y','c','c','c','c','y','y','y','b','b','b','b'};
    showskeletons2(im,boxes(1,:),colorset,model.pa);
    %pause;
    %showboxes(im, boxes(1,:),colorset); % show the best detection
    %showboxes(im, boxes,colorset);  % show all detections
    fprintf('detection took %.1f seconds\n',dettime);
    fprintf('Frame Number %d Ended\n',i);
    
    %disp('press any key to continue');

   % pause;
end
clc;
fprintf('detection completed press any key\n');
%pause;
hist_action=[0 0 0 0 0];
for j=1:5
	if(j==1)
		clc;
		load('bend');
	elseif(j==2)
		clc;
		load('jump');
	elseif(j==3)
		clc;
		load('walk');
	elseif(j==4)
		clc;
	%	disp('WAVE');
		load('wave');
	else
		clc;
	%	disp('Sit');
		load('sit');
	end
	load('test');
	unique_number=0;
	for i  =1: video_no-1
		%disp(video(i,:,:));
		
		[D, dist, matched_vector] = lcs(video,walk_vector_test,i);
		
	%	disp('Matched vector are on its way = ');
	%	disp(matched_vector);
	%	disp(dist);
		unique_number = unique_number + dist;
	end
	unique_number = double(unique_number);
	hist_action(j)=unique_number;
	%disp(model.pa);
%	disp('done');
%	disp(video_no);
%	disp(unique_number);
end
nelements=[1 2 3 4 5];
%nelements={'walk','bend','wave','jump','sit'};

str = {'bend'; 'jump'; 'walk'; 'wave'; 'sit'};

figure
bar(hist_action);
set(gca, 'XTickLabel',str, 'XTick',1:numel(str));
ylabel('count LCS');

%clc;
disp('done_all__l');
%disp(walk_vector_test);
%disp(frame_counter);
disp(' 1. Result is true, 2. bend , 3.jump ,4. walk, 5. wave 6.sit'); 
result = input('Enter correct match');

if(result==2)	% save in bend
load('bend');
for k=1:(frame_counter-1)
video(video_no,k,:)=walk_vector_test(k,:);
end
video_no=video_no+1;
save('bend','video','video_no','frame_no','angle_no');
end

if(result==3)	% save in jump
load('jump');
for k=1:(frame_counter-1)
video(video_no,k,:)=walk_vector_test(k,:);
end
video_no=video_no+1;
save('jump','video','video_no','frame_no','angle_no');
end


if(result==4)	% save in walk
load('walk');
for k=1:(frame_counter-1)
video(video_no,k,:)=walk_vector_test(k,:);
end
video_no=video_no+1;
save('walk','video','video_no','frame_no','angle_no');
end


if(result==5)	% save in wave
load('wave');
for k=1:(frame_counter-1)
video(video_no,k,:)=walk_vector_test(k,:);
end
video_no=video_no+1;
save('wave','video','video_no','frame_no','angle_no');

endif(result==6)	% save in wave
load('sit');
for k=1:(frame_counter-1)
video(video_no,k,:)=walk_vector_test(k,:);
end
video_no=video_no+1;
save('sit','video','video_no','frame_no','angle_no');
end

frame_counter=1;
walk_vector_test=zeros(1,8);
save('test','walk_vector_test','frame_counter');
	