function [D, dist, aLongestString] = lcs(X,Y,vid_x)
%disp('#############X is #####');
%%disp(X);
%disp('#############X was #####');
%%disp(Y);

%%%Calculates the longest common substring between to strings.
%%%Code written by David Cumin
%%%email: d.cumin@auckland.ac.nz
%%%INPUT
%%%X, Y - both are strings e.g. 'test' or 'stingtocompare'
%%%OUTPUT
%%%D is the substring over the length of the shor string
%%%dist is the length of the substring
%%%aLongestString is a sting of length dist (only one of potentially many)

%%%For example
%%% X = 'abcabc';
%%% Y = 'adcbac';
%%% [D dist str] = LCS(X,Y);
%%% results in:
%%% D = 0.6667 
%%% dist = 4
%%% str = acbc
%%% this is seen for X: 'a-c-bc' and Y: 'a-cb-c'

%%%Make matrix

n =size(X,2);
m =size(Y,1);
%disp('mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm');
%disp(size(X));
%disp(size(Y));
L=zeros(n+1,m+1);
L(1,:)=0;
L(:,1)=0;
b = zeros(n+1,m+1);
b(:,1)=1;%%%Up
b(1,:)=2;%%%Left

for i = 2:n+1
    for j = 2:m+1
		%%disp('#############X is #####');
		%%disp(i);
		%%disp(j);
		%%disp(X(i-1,:));
		if(X(vid_x,i-1,1)==0 && X(vid_x,i-1,2)==0 && X(vid_x,i-1,3)==0 && X(vid_x,i-1,4)==0 && X(vid_x,i-1,5)==0 && X(vid_x,i-1,6)==0 && X(vid_x,i-1,7)==0 && X(vid_x,i-1,8)==0)
			continue;
		end
        thresh = check_star_model(X,Y,i-1,j-1,vid_x);
        if (thresh == 1)
            L(i,j) = L(i-1,j-1) + 1;
            b(i,j) = 3;                             %%%Up and left
        else
            L(i,j) = L(i-1,j-1);
        end
        if(L(i-1,j) >= L(i,j))
            L(i,j) = L(i-1,j);
            b(i,j) = 1;%Up
        end
        if(L(i,j-1) >= L(i,j))
            L(i,j) = L(i,j-1);
            b(i,j) = 2;%Left
        end
    end
end
L(:,1) = [];
L(1,:) = [];
b(:,1) = [];
b(1,:) = [];
dist = L(n,m);

D = (dist / min(m,n));
if(dist == 0)
    aLongestString(1,8) = 0;
else
    %%%now backtrack to find the longest subsequence
    i = n;
    j = m;
    p = dist;
    aLongestString(1,8) = 0;
    while(i>0 && j>0)
        if(b(i,j) == 3)
            aLongestString(p,:) = X(vid_x,i,:);
            p = p-1;
            i = i-1;
            j = j-1;
        elseif(b(i,j) == 1)
            i = i-1;
        elseif(b(i,j) == 2)
            j = j-1;
        end
    end

 %   if ischar(aLongestString{1})
%        aLongestString = char(aLongestString)';
 %   else
  %      aLongestString = cell2mat(aLongestString);
  %  end
end

end
function thresh = check_star_model(A,B,sizea,sizeb,vid_x)
	
	%disp('--------------------');
	%disp(A(vid_x,sizea,:));
	%disp(B(sizeb,:));
	%disp('---------------------');
	%total_p=0; 
	penalty = 0;
    threshold = 60;
    for k = 1:8
        if(abs(A(vid_x,sizea,k)-B(sizeb,k))<=20)
            penalty = penalty;
        else
            penalty = penalty + abs(A(vid_x,sizea,k)-B(sizeb,k))-20;
			%total_p=total_p+abs(A(i)-B(i))-10;
        end
		
    end
	%disp('************************');
	%disp(penalty);
	%%disp(total_p);
    if(penalty < threshold )
        thresh = 1;
    else
        thresh = 0;
    end
end