function showskeletons(im, boxes, partcolor, parent)

imagesc(im); axis image; axis on; hold on;
if ~isempty(boxes)
  numparts = length(partcolor);
  box = boxes(:,1:4*numparts);
  xy = reshape(box,size(box,1),4,numparts);
  xy = permute(xy,[1 3 2]);
  for n = 1:size(xy,1)
    x1 = xy(n,:,1); y1 = xy(n,:,2); x2 = xy(n,:,3); y2 = xy(n,:,4);
    x = (x1+x2)/2; y = (y1+y2)/2;
    i =0;
    for child = 2:numparts
      x1 = x(parent(child));
      y1 = y(parent(child));
      x2 = x(child);
      y2 = y(child);
      line([x1 x2],[y1 y2],'color',partcolor{child},'linewidth',4);
    %  fprintf('parent = %f \t child = %f \n', parent(child), child );
     % fprintf('x-cord = %f \t y-cord = %f \n', x(child) ,y(child));

    end
  end
end
drawnow;
%label = {'head','neck','L-Sho','L-mus','L-elb','L-arm','L-wrist','L-chest','L-waist','L-mid-thigh','L-thigh','L-knee','L-leg','L-toe','R-Sho','R-mus','R-elb','R-arm','R-wrist','R-chest','R-waist','R-mid-thigh','R-thigh','R-knee','R-leg','R-toe'};
label = cellstr(num2str([1:26]'));
plot(x,y,'rx');
text(x,y,label,'Color','green');
parts2(im,boxes,partcolor,parent,x,y,label);



